package com.zcloud.controller.system;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.system.ScheduleService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.Tools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 说明：日程安排
 * 作者：zCloud
 * 官网：
 */
@Controller
@RequestMapping("/app/schedule")
public class AppScheduleController extends BaseController {

	@Autowired
	private ScheduleService scheduleService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		//pd.put("SCHEDULE_ID", this.get32UUID());		//主键
//		pd.put("USERNAME", Jurisdiction.getUsername());	//用户名
		scheduleService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		scheduleService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		scheduleService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("USERNAME", Jurisdiction.getUsername()); 				//只能查看自己的数据
		page.setPd(pd);
		List<PageData>	varList = scheduleService.list(page);			//列出Schedule列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	/**获取数据
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/getData")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "获取数据")
	public Object getData() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("USERNAME", pd.get("USERNAME")); 				//只能查看自己的数据
		if(pd.getString("CDATA").equals("")) {
			pd.put("CDATA", DateUtil.getDay());
		}else {
			pd.put("CDATA", pd.getString("CDATA"));
		}
		List<PageData>	varList = scheduleService.listAll(pd);			//列出Schedule列表
		for(PageData spd : varList) {
			spd.put("id", spd.getString("SCHEDULE_ID"));
			spd.put("title", spd.getString("TITLE"));
			spd.put("desc", spd.getString("FHDESC"));
			spd.put("date", spd.getString("CDATA"));
			spd.remove("SCHEDULE_ID");
			spd.remove("USERNAME");
			spd.remove("TITLE");
			spd.remove("CDATA");
			spd.remove("FHDESC");
		}
		map.put("varList", varList);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = scheduleService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "日程安排",instructionsOperate = "日程安排",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			scheduleService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

}
